Index: /palm/trunk/SOURCE/spectra_mod.f90
===================================================================
--- /palm/trunk/SOURCE/spectra_mod.f90	(revision 4590)
+++ /palm/trunk/SOURCE/spectra_mod.f90	(revision 4591)
@@ -291,583 +314,614 @@
 !>
 !> @todo Output of netcdf data format and compression level
-!------------------------------------------------------------------------------!
-    SUBROUTINE spectra_header ( io )
-
-       USE control_parameters,                                                 &
-           ONLY:  dt_averaging_input_pr
-
-!       USE netcdf_interface,                                                  &
-!           ONLY:  netcdf_data_format_string, netcdf_deflate
-
-       IMPLICIT NONE
-
-!       CHARACTER (LEN=40) ::  output_format       !< internal string
-
-       INTEGER(iwp) ::  i                         !< internal counter
-       INTEGER(iwp), INTENT(IN) ::  io            !< Unit of the output file
-
-!
-!--    Spectra output
-       IF ( dt_dosp /= 9999999.9_wp )  THEN
-          WRITE ( io, 1 )
-
-!          output_format = netcdf_data_format_string
-!          IF ( netcdf_deflate == 0 )  THEN
-!             WRITE ( io, 2 )  output_format
-!          ELSE
-!             WRITE ( io, 3 )  TRIM( output_format ), netcdf_deflate
-!          ENDIF
-          WRITE ( io, 2 )  'see profiles or other quantities'
-          WRITE ( io, 4 )  dt_dosp
-          IF ( skip_time_dosp /= 0.0_wp )  WRITE ( io, 5 )  skip_time_dosp
-          WRITE ( io, 6 )  ( data_output_sp(i), i = 1,10 ),     &
-                           ( spectra_direction(i), i = 1,10 ),  &
-                           ( comp_spectra_level(i), i = 1,100 ), &
-                           averaging_interval_sp, dt_averaging_input_pr
-       ENDIF
-
-     1 FORMAT ('    Spectra:')
-     2 FORMAT ('       Output format: ',A/)
-!     3 FORMAT ('       Output format: ',A, '   compressed with level: ',I1/)
-     4 FORMAT ('       Output every ',F7.1,' s'/)
-     5 FORMAT ('       No output during initial ',F8.2,' s')
-     6 FORMAT ('       Arrays:     ', 10(A5,',')/                         &
-               '       Directions: ', 10(A5,',')/                         &
-               '       height levels  k = ', 20(I3,',')/                  &
-               '                          ', 20(I3,',')/                  &
-               '                          ', 20(I3,',')/                  &
-               '                          ', 20(I3,',')/                  &
-               '                          ', 19(I3,','),I3,'.'/           &
-               '       Time averaged over ', F7.1, ' s,' /                &
-               '       Profiles for the time averaging are taken every ', &
-                    F6.1,' s')
-
-    END SUBROUTINE spectra_header
-
-
-
-    SUBROUTINE calc_spectra
-
-       USE arrays_3d,                                                          &
-           ONLY:  d
-#if defined( __parallel )
-       USE arrays_3d,                                                          &
-           ONLY:  tend
-#endif
-
-       USE control_parameters,                                                 &
-           ONLY:  bc_lr_cyc, bc_ns_cyc, message_string, psolver
-
-       USE cpulog,                                                             &
-           ONLY:  cpu_log, log_point
-
-       USE fft_xy,                                                             &
-           ONLY:  fft_init
-
-       USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzt
-
-       USE kinds
-
-       USE pegrid,                                                             &
-           ONLY:  myid
-#if defined( __parallel )
-       USE pegrid,                                                             &
-           ONLY:  pdims
-#endif
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  m  !<
-       INTEGER(iwp) ::  pr !<
-
-
-!
-!--    Check if user gave any levels for spectra to be calculated
-       IF ( comp_spectra_level(1) == 999999 )  RETURN
-
-       CALL cpu_log( log_point(30), 'calc_spectra', 'start' )
-
-!
-!--    Initialize spectra related quantities
-       CALL spectra_init
-
-!
-!--    Initialize ffts
-       CALL fft_init
-
-!
-!--    Reallocate array d in required size
-       IF ( psolver(1:9) == 'multigrid' )  THEN
-          DEALLOCATE( d )
-          ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr) )
-       ENDIF
-
-       m = 1
-       DO WHILE ( data_output_sp(m) /= ' '  .AND.  m <= 10 )
-!
-!--       Transposition from z --> x  ( y --> x in case of a 1d-decomposition
-!--       along x)
-          IF ( INDEX( spectra_direction(m), 'x' ) /= 0 )  THEN
-
-!
-!--          Calculation of spectra works for cyclic boundary conditions only
-             IF ( .NOT. bc_lr_cyc )  THEN
-
-                message_string = 'non-cyclic lateral boundaries along x do'//  &
-                                 ' not &  allow calculation of spectra along x'
-                CALL message( 'calc_spectra', 'PA0160', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             CALL preprocess_spectra( m, pr )
-
-#if defined( __parallel )
-             IF ( pdims(2) /= 1 )  THEN
-                CALL resort_for_zx( d, tend )
-                CALL transpose_zx( tend, d )
-             ELSE
-                CALL transpose_yxd( d, d )
-             ENDIF
-             CALL calc_spectra_x( d, m )
-#else
-             message_string = 'sorry, calculation of spectra in non paral' //  &
-                              'lel mode& is still not realized'
-             CALL message( 'calc_spectra', 'PA0161', 1, 2, 0, 6, 0 )
-#endif
-
-          ENDIF
-
-!
-!--       Transposition from z --> y (d is rearranged only in case of a
-!--       1d-decomposition along x)
-          IF ( INDEX( spectra_direction(m), 'y' ) /= 0 )  THEN
-
-!
-!--          Calculation of spectra works for cyclic boundary conditions only
-             IF ( .NOT. bc_ns_cyc )  THEN
-                IF ( myid == 0 )  THEN
-                   message_string = 'non-cyclic lateral boundaries along y' // &
-                                    ' do not & allow calculation of spectra' //&
-                                    ' along y'
-                   CALL message( 'calc_spectra', 'PA0162', 1, 2, 0, 6, 0 )
-                ENDIF
-                CALL local_stop
-             ENDIF
-
-             CALL preprocess_spectra( m, pr )
-
-#if defined( __parallel )
-             CALL transpose_zyd( d, d )
-             CALL calc_spectra_y( d, m )
-#else
-             message_string = 'sorry, calculation of spectra in non paral' //  &
-                              'lel mode& is still not realized'
-             CALL message( 'calc_spectra', 'PA0161', 1, 2, 0, 6, 0 )
-#endif
-
-          ENDIF
-
-!
-!--       Increase counter for next spectrum
-          m = m + 1
-          
-       ENDDO
-
-!
-!--    Increase counter for averaging process in routine plot_spectra
-       average_count_sp = average_count_sp + 1
-
-       CALL cpu_log( log_point(30), 'calc_spectra', 'stop' )
-
-    END SUBROUTINE calc_spectra
-
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE spectra_header ( io )
+
+    USE control_parameters,                                                                        &
+        ONLY:  dt_averaging_input_pr
+
+!    USE netcdf_interface,                                                                          &
+!        ONLY:  netcdf_data_format_string,                                                          &
+!               netcdf_deflate
+
+    IMPLICIT NONE
+
+!    CHARACTER (LEN=40) ::  output_format !< internal string
+
+    INTEGER(iwp) ::  i               !< internal counter
+    INTEGER(iwp), INTENT(IN) ::  io  !< unit of the output file
+
+!
+!-- Spectra output
+    IF ( dt_dosp /= 9999999.9_wp )  THEN
+       WRITE ( io, 1 )
+
+!       output_format = netcdf_data_format_string
+!       IF ( netcdf_deflate == 0 )  THEN
+!          WRITE ( io, 2 )  output_format
+!       ELSE
+!          WRITE ( io, 3 )  TRIM( output_format ), netcdf_deflate
+!       ENDIF
+       WRITE ( io, 2 )  'see profiles or other quantities'
+       WRITE ( io, 4 )  dt_dosp
+       IF ( skip_time_dosp /= 0.0_wp )  WRITE ( io, 5 )  skip_time_dosp
+       WRITE ( io, 6 )  ( data_output_sp(i), i = 1,10 ),                                           &
+                        ( spectra_direction(i), i = 1,10 ),                                        &
+                        ( comp_spectra_level(i), i = 1,100 ),                                      &
+                        averaging_interval_sp, dt_averaging_input_pr
+    ENDIF
+
+  1 FORMAT ('    Spectra:')
+  2 FORMAT ('       Output format: ',A/)
+!  3 FORMAT ('       Output format: ',A, '   compressed with level: ',I1/)
+  4 FORMAT ('       Output every ',F7.1,' s'/)
+  5 FORMAT ('       No output during initial ',F8.2,' s')
+  6 FORMAT ('       Arrays:     ', 10(A5,',')/                                                     &
+            '       Directions: ', 10(A5,',')/                                                     &
+            '       height levels  k = ', 20(I3,',')/                                              &
+            '                          ', 20(I3,',')/                                              &
+            '                          ', 20(I3,',')/                                              &
+            '                          ', 20(I3,',')/                                              &
+            '                          ', 19(I3,','),I3,'.'/                                       &
+            '       Time averaged over ', F7.1, ' s,' /                                            &
+            '       Profiles for the time averaging are taken every ',                             &
+                 F6.1,' s')
+
+ END SUBROUTINE spectra_header
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing subroutine description.
-!------------------------------------------------------------------------------!
-    SUBROUTINE preprocess_spectra( m, pr )
-
-       USE arrays_3d,                                                          &
-           ONLY:  d, pt, q, s, u, v, w
-
-       USE indices,                                                            &
-           ONLY:  ngp_2dh, nxl, nxr, nyn, nys, nzb, nzt
-
-       USE kinds
-
-#if defined( __parallel )
-#if !defined( __mpifh )
-       USE MPI
-#endif
-
-       USE pegrid,                                                             &
-           ONLY:  collective_wait, comm2d, ierr
-#endif
-
-       USE statistics,                                                         &
-           ONLY:  hom
-
-
-       IMPLICIT NONE
-
-#if defined( __parallel )
-#if defined( __mpifh )
-       INCLUDE "mpif.h"
-#endif
-#endif
-
-       INTEGER(iwp) :: i  !<
-       INTEGER(iwp) :: j  !<
-       INTEGER(iwp) :: k  !<
-       INTEGER(iwp) :: m  !<
-       INTEGER(iwp) :: pr !<
-
-       REAL(wp), DIMENSION(nzb:nzt+1) :: var_d_l
-
-       SELECT CASE ( TRIM( data_output_sp(m) ) )
-          
-       CASE ( 'u' )
-          pr = 1
-          d(nzb+1:nzt,nys:nyn,nxl:nxr) = u(nzb+1:nzt,nys:nyn,nxl:nxr)
-       
-       CASE ( 'v' )
-          pr = 2
-          d(nzb+1:nzt,nys:nyn,nxl:nxr) = v(nzb+1:nzt,nys:nyn,nxl:nxr)
-       
-       CASE ( 'w' )
-          pr = 3
-          d(nzb+1:nzt,nys:nyn,nxl:nxr) = w(nzb+1:nzt,nys:nyn,nxl:nxr)
-       
-       CASE ( 'theta' )
-          pr = 4
-          d(nzb+1:nzt,nys:nyn,nxl:nxr) = pt(nzb+1:nzt,nys:nyn,nxl:nxr)
-       
-       CASE ( 'q' )
-          pr = 41
-          d(nzb+1:nzt,nys:nyn,nxl:nxr) = q(nzb+1:nzt,nys:nyn,nxl:nxr)
-          
-       CASE ( 's' )
-          pr = 117
-          d(nzb+1:nzt,nys:nyn,nxl:nxr) = s(nzb+1:nzt,nys:nyn,nxl:nxr)
-       
-       CASE DEFAULT
-!
-!--       The DEFAULT case is reached either if the parameter data_output_sp(m)
-!--       contains a wrong character string or if the user has coded a special
-!--       case in the user interface. There, the subroutine user_spectra
-!--       checks which of these two conditions applies.
-          CALL user_spectra( 'preprocess', m, pr )
-          
-       END SELECT
-
-!
-!--    Subtract horizontal mean from the array, for which spectra have to be
-!--    calculated. Moreover, calculate variance of the respective quantitiy, 
-!--    later used for normalizing spectra output. 
-       var_d_l(:) = 0.0_wp
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                d(k,j,i)   = d(k,j,i) - hom(k,1,pr,0)
-                var_d_l(k) = var_d_l(k) + d(k,j,i) * d(k,j,i)
-             ENDDO
-          ENDDO
-       ENDDO
-!
-!--    Compute total variance from local variances
-       var_d(:) = 0.0_wp
-#if defined( __parallel ) 
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( var_d_l(0), var_d(0), nzt+1-nzb, MPI_REAL, MPI_SUM, &
-                           comm2d, ierr )
+!--------------------------------------------------------------------------------------------------!
+
+ SUBROUTINE calc_spectra
+
+    USE arrays_3d,                                                                                 &
+        ONLY:  d
+#if defined( __parallel )
+    USE arrays_3d,                                                                                 &
+        ONLY:  tend
+#endif
+
+    USE control_parameters,                                                                        &
+        ONLY:  bc_lr_cyc,                                                                          &
+               bc_ns_cyc,                                                                          &
+               message_string,                                                                     &
+               psolver
+
+    USE cpulog,                                                                                    &
+        ONLY:  cpu_log,                                                                            &
+               log_point
+
+    USE fft_xy,                                                                                    &
+        ONLY:  fft_init
+
+    USE indices,                                                                                   &
+        ONLY:  nxl,                                                                                &
+               nxr,                                                                                &
+               nyn,                                                                                &
+               nys,                                                                                &
+               nzb,                                                                                &
+               nzt
+
+    USE kinds
+
+    USE pegrid,                                                                                    &
+        ONLY:  myid
+#if defined( __parallel )
+    USE pegrid,                                                                                    &
+        ONLY:  pdims
+#endif
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  m   !<
+    INTEGER(iwp) ::  pr  !<
+
+
+!
+!-- Check if user gave any levels for spectra to be calculated
+    IF ( comp_spectra_level(1) == 999999 )  RETURN
+
+    CALL cpu_log( log_point(30), 'calc_spectra', 'start' )
+
+!
+!-- Initialize spectra related quantities
+    CALL spectra_init
+
+!
+!-- Initialize ffts
+    CALL fft_init
+
+!
+!-- Reallocate array d in required size
+    IF ( psolver(1:9) == 'multigrid' )  THEN
+       DEALLOCATE( d )
+       ALLOCATE( d(nzb+1:nzt,nys:nyn,nxl:nxr) )
+    ENDIF
+
+    m = 1
+    DO WHILE ( data_output_sp(m) /= ' '  .AND.  m <= 10 )
+!
+!--    Transposition from z --> x  ( y --> x in case of a 1d-decomposition along x)
+       IF ( INDEX( spectra_direction(m), 'x' ) /= 0 )  THEN
+
+!
+!--       Calculation of spectra works for cyclic boundary conditions only
+          IF ( .NOT. bc_lr_cyc )  THEN
+
+             message_string = 'non-cyclic lateral boundaries along x do' //                        &
+                              ' not &  allow calculation of spectra along x'
+             CALL message( 'calc_spectra', 'PA0160', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          CALL preprocess_spectra( m, pr )
+
+#if defined( __parallel )
+          IF ( pdims(2) /= 1 )  THEN
+             CALL resort_for_zx( d, tend )
+             CALL transpose_zx( tend, d )
+          ELSE
+             CALL transpose_yxd( d, d )
+          ENDIF
+          CALL calc_spectra_x( d, m )
 #else
-       var_d(:) = var_d_l(:)
-#endif
-       var_d(:) = var_d(:) / ngp_2dh(0)
-
-    END SUBROUTINE preprocess_spectra
-
-
-!------------------------------------------------------------------------------!
+          message_string = 'sorry, calculation of spectra in non parallel mode& is still not ' //  &
+                           'realized'
+          CALL message( 'calc_spectra', 'PA0161', 1, 2, 0, 6, 0 )
+#endif
+
+       ENDIF
+
+!
+!--    Transposition from z --> y (d is rearranged only in case of a 1d-decomposition along x)
+       IF ( INDEX( spectra_direction(m), 'y' ) /= 0 )  THEN
+
+!
+!--       Calculation of spectra works for cyclic boundary conditions only
+          IF ( .NOT. bc_ns_cyc )  THEN
+             IF ( myid == 0 )  THEN
+                message_string = 'non-cyclic lateral boundaries along y' //                        &
+                                 ' do not & allow calculation of spectra along y'
+                CALL message( 'calc_spectra', 'PA0162', 1, 2, 0, 6, 0 )
+             ENDIF
+             CALL local_stop
+          ENDIF
+
+          CALL preprocess_spectra( m, pr )
+
+#if defined( __parallel )
+          CALL transpose_zyd( d, d )
+          CALL calc_spectra_y( d, m )
+#else
+          message_string = 'sorry, calculation of spectra in non parallel mode& is still not ' //  &
+                           'realized'
+          CALL message( 'calc_spectra', 'PA0161', 1, 2, 0, 6, 0 )
+#endif
+
+       ENDIF
+
+!
+!--    Increase counter for next spectrum
+       m = m + 1
+
+    ENDDO
+
+!
+!-- Increase counter for averaging process in routine plot_spectra
+    average_count_sp = average_count_sp + 1
+
+    CALL cpu_log( log_point(30), 'calc_spectra', 'stop' )
+
+ END SUBROUTINE calc_spectra
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing subroutine description.
-!------------------------------------------------------------------------------!
-#if defined( __parallel )
-    SUBROUTINE calc_spectra_x( ddd, m )
-
-       USE fft_xy,                                                             &
-           ONLY:  fft_x_1d
-
-       USE grid_variables,                                                     &
-           ONLY:  dx
-
-       USE indices,                                                            &
-           ONLY:  nx, ny
-
-       USE kinds
-
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE preprocess_spectra( m, pr )
+
+    USE arrays_3d,                                                                                 &
+        ONLY:  d,                                                                                  &
+               pt,                                                                                 &
+               q,                                                                                  &
+               s,                                                                                  &
+               u,                                                                                  &
+               v,                                                                                  &
+               w
+
+    USE indices,                                                                                   &
+        ONLY:  ngp_2dh,                                                                            &
+               nxl,                                                                                &
+               nxr,                                                                                &
+               nyn,                                                                                &
+               nys,                                                                                &
+               nzb,                                                                                &
+               nzt
+
+    USE kinds
+
+#if defined( __parallel )
 #if !defined( __mpifh )
-       USE MPI
-#endif
-
-       USE pegrid,                                                             &
-           ONLY:  comm2d, ierr, myid
-
-       USE transpose_indices,                                                  &
-           ONLY:  nyn_x, nys_x, nzb_x, nzt_x
-
-
-       IMPLICIT NONE
-
+    USE MPI
+#endif
+
+    USE pegrid,                                                                                    &
+        ONLY:  collective_wait,                                                                    &
+               comm2d,                                                                             &
+               ierr
+#endif
+
+    USE statistics,                                                                                &
+        ONLY:  hom
+
+
+    IMPLICIT NONE
+
+#if defined( __parallel )
 #if defined( __mpifh )
-       INCLUDE "mpif.h"
-#endif
-
-       INTEGER(iwp) ::  i         !<
-       INTEGER(iwp) ::  j         !<
-       INTEGER(iwp) ::  k         !<
-       INTEGER(iwp) ::  m         !<
-       INTEGER(iwp) ::  n         !<
-
-       REAL(wp) ::  exponent     !<
-       REAL(wp) ::  sum_spec_dum !< wavenumber-integrated spectrum
-    
-       REAL(wp), DIMENSION(0:nx) ::  work !<
-    
-       REAL(wp), DIMENSION(0:nx/2) ::  sums_spectra_l !<
-    
-       REAL(wp), DIMENSION(0:nx/2,100) ::  sums_spectra !<
-    
-       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x,nzb_x:nzt_x) ::  ddd !<
-
-!
-!--    Exponent for geometric average
-       exponent = 1.0_wp / ( ny + 1.0_wp )
-
-!
-!--    Loop over all levels defined by the user
-       n = 1
-       DO WHILE ( comp_spectra_level(n) /= 999999  .AND.  n <= 100 )
-
-          k = comp_spectra_level(n)
-
-!
-!--       Calculate FFT only if the corresponding level is situated on this PE
-          IF ( k >= nzb_x  .AND.  k <= nzt_x )  THEN
-          
-             DO  j = nys_x, nyn_x
-
-                work = ddd(0:nx,j,k)
-                CALL fft_x_1d( work, 'forward' )
-
-                ddd(0,j,k) = dx * work(0)**2
-                DO  i = 1, nx/2
-                   ddd(i,j,k) = dx * ( work(i)**2 + work(nx+1-i)**2 )
-                ENDDO
-
-             ENDDO
-
-!
-!--          Local sum and geometric average of these spectra
-!--          (WARNING: no global sum should be performed, because floating
-!--          point overflow may occur)
-             DO  i = 0, nx/2
-
-                sums_spectra_l(i) = 1.0_wp
-                DO  j = nys_x, nyn_x
-                   sums_spectra_l(i) = sums_spectra_l(i) * ddd(i,j,k)**exponent
-                ENDDO
-
-             ENDDO
-          
-          ELSE
-
-             sums_spectra_l = 1.0_wp
-
-          ENDIF
-
-!
-!--       Global sum of spectra on PE0 (from where they are written on file)
-          sums_spectra(:,n) = 0.0_wp
-#if defined( __parallel )   
-          CALL MPI_BARRIER( comm2d, ierr )  ! Necessary?
-          CALL MPI_REDUCE( sums_spectra_l(0), sums_spectra(0,n), nx/2+1,       &
-                           MPI_REAL, MPI_PROD, 0, comm2d, ierr )
+    INCLUDE "mpif.h"
+#endif
+#endif
+
+    INTEGER(iwp) ::  i   !<
+    INTEGER(iwp) ::  j   !<
+    INTEGER(iwp) ::  k   !<
+    INTEGER(iwp) ::  m   !<
+    INTEGER(iwp) ::  pr  !<
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  var_d_l  !<
+
+    SELECT CASE ( TRIM( data_output_sp(m) ) )
+
+    CASE ( 'u' )
+       pr = 1
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = u(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+    CASE ( 'v' )
+       pr = 2
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = v(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+    CASE ( 'w' )
+       pr = 3
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = w(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+    CASE ( 'theta' )
+       pr = 4
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = pt(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+    CASE ( 'q' )
+       pr = 41
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = q(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+    CASE ( 's' )
+       pr = 117
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = s(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+    CASE DEFAULT
+!
+!--    The DEFAULT case is reached either if the parameter data_output_sp(m) contains a wrong
+!--    character string or if the user has coded a special case in the user interface. There, the
+!--    subroutine user_spectra checks which of these two conditions applies.
+       CALL user_spectra( 'preprocess', m, pr )
+
+    END SELECT
+
+!
+!-- Subtract horizontal mean from the array, for which spectra have to be calculated. Moreover,
+!-- calculate variance of the respective quantitiy, later used for normalizing spectra output.
+    var_d_l(:) = 0.0_wp
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i)   = d(k,j,i) - hom(k,1,pr,0)
+             var_d_l(k) = var_d_l(k) + d(k,j,i) * d(k,j,i)
+          ENDDO
+       ENDDO
+    ENDDO
+!
+!-- Compute total variance from local variances
+    var_d(:) = 0.0_wp
+#if defined( __parallel )
+    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+    CALL MPI_ALLREDUCE( var_d_l(0), var_d(0), nzt+1-nzb, MPI_REAL, MPI_SUM, comm2d, ierr )
 #else
-          sums_spectra(:,n) = sums_spectra_l
-#endif
-!
-!--       Normalize spectra by variance
-          sum_spec_dum = SUM( sums_spectra(1:nx/2,n) )
-
-          IF ( sum_spec_dum /= 0.0_wp )  THEN
-             sums_spectra(1:nx/2,n) = sums_spectra(1:nx/2,n) *                 &
-                                      var_d(k) / sum_spec_dum
-          ENDIF
-          n = n + 1
-
-       ENDDO
-       n = n - 1
-
-       IF ( myid == 0 )  THEN
-!
-!--       Sum of spectra for later averaging (see routine data_output_spectra)
-          DO  i = 1, nx/2
-             DO k = 1, n
-                spectrum_x(i,k,m) = spectrum_x(i,k,m) + sums_spectra(i,k)
-             ENDDO
-          ENDDO
-
-       ENDIF
-!
-!--    n_sp_x is needed by data_output_spectra_x
-       n_sp_x = n
-
-    END SUBROUTINE calc_spectra_x
-#endif
-
-
-!------------------------------------------------------------------------------!
+    var_d(:) = var_d_l(:)
+#endif
+    var_d(:) = var_d(:) / ngp_2dh(0)
+
+ END SUBROUTINE preprocess_spectra
+
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> @todo Missing subroutine description.
-!------------------------------------------------------------------------------!
-#if defined( __parallel )
-    SUBROUTINE calc_spectra_y( ddd, m )
-
-       USE fft_xy,                                                             &
-           ONLY:  fft_y_1d
-
-       USE grid_variables,                                                     &
-           ONLY:  dy
-
-       USE indices,                                                            &
-           ONLY:  nx, ny
-
-       USE kinds
+!--------------------------------------------------------------------------------------------------!
+#if defined( __parallel )
+ SUBROUTINE calc_spectra_x( ddd, m )
+
+    USE fft_xy,                                                                                    &
+        ONLY:  fft_x_1d
+
+    USE grid_variables,                                                                            &
+        ONLY:  dx
+
+    USE indices,                                                                                   &
+        ONLY:  nx,                                                                                 &
+               ny
+
+    USE kinds
 
 #if !defined( __mpifh )
-       USE MPI
-#endif
-
-       USE pegrid,                                                             &
-           ONLY:  comm2d, ierr, myid
-
-       USE transpose_indices,                                                  &
-           ONLY:  nxl_yd, nxr_yd, nzb_yd, nzt_yd
-
-
-       IMPLICIT NONE
+    USE MPI
+#endif
+
+    USE pegrid,                                                                                    &
+        ONLY:  comm2d,                                                                             &
+               ierr,                                                                               &
+               myid
+
+    USE transpose_indices,                                                                         &
+        ONLY:  nyn_x,                                                                              &
+               nys_x,                                                                              &
+               nzb_x,                                                                              &
+               nzt_x
+
+
+    IMPLICIT NONE
 
 #if defined( __mpifh )
-       INCLUDE "mpif.h"
-#endif
-
-       INTEGER(iwp) ::  i         !<
-       INTEGER(iwp) ::  j         !<
-       INTEGER(iwp) ::  k         !<
-       INTEGER(iwp) ::  m         !<
-       INTEGER(iwp) ::  n         !<
-
-       REAL(wp) ::  exponent !<
-       REAL(wp) ::  sum_spec_dum !< wavenumber-integrated spectrum
-    
-       REAL(wp), DIMENSION(0:ny) ::  work !<
-    
-       REAL(wp), DIMENSION(0:ny/2) ::  sums_spectra_l !<
-    
-       REAL(wp), DIMENSION(0:ny/2,100) ::  sums_spectra !<
-    
-       REAL(wp), DIMENSION(0:ny,nxl_yd:nxr_yd,nzb_yd:nzt_yd) :: ddd !<
-
-
-!
-!--    Exponent for geometric average
-       exponent = 1.0_wp / ( nx + 1.0_wp )
-
-!
-!--    Loop over all levels defined by the user
-       n = 1
-       DO WHILE ( comp_spectra_level(n) /= 999999  .AND.  n <= 100 )
-
-          k = comp_spectra_level(n)
-
-!
-!--       Calculate FFT only if the corresponding level is situated on this PE
-          IF ( k >= nzb_yd  .AND.  k <= nzt_yd )  THEN
-          
+    INCLUDE "mpif.h"
+#endif
+
+    INTEGER(iwp) ::  i  !<
+    INTEGER(iwp) ::  j  !<
+    INTEGER(iwp) ::  k  !<
+    INTEGER(iwp) ::  m  !<
+    INTEGER(iwp) ::  n  !<
+
+    REAL(wp) ::  exponent      !<
+    REAL(wp) ::  sum_spec_dum  !< wavenumber-integrated spectrum
+
+    REAL(wp), DIMENSION(0:nx) ::  work  !<
+
+    REAL(wp), DIMENSION(0:nx/2) ::  sums_spectra_l  !<
+
+    REAL(wp), DIMENSION(0:nx/2,100) ::  sums_spectra  !<
+
+    REAL(wp), DIMENSION(0:nx,nys_x:nyn_x,nzb_x:nzt_x) ::  ddd  !<
+
+!
+!-- Exponent for geometric average
+    exponent = 1.0_wp / ( ny + 1.0_wp )
+
+!
+!-- Loop over all levels defined by the user
+    n = 1
+    DO WHILE ( comp_spectra_level(n) /= 999999  .AND.  n <= 100 )
+
+       k = comp_spectra_level(n)
+
+!
+!--    Calculate FFT only if the corresponding level is situated on this PE
+       IF ( k >= nzb_x  .AND.  k <= nzt_x )  THEN
+
+          DO  j = nys_x, nyn_x
+
+             work = ddd(0:nx,j,k)
+             CALL fft_x_1d( work, 'forward' )
+
+             ddd(0,j,k) = dx * work(0)**2
+             DO  i = 1, nx/2
+                ddd(i,j,k) = dx * ( work(i)**2 + work(nx+1-i)**2 )
+             ENDDO
+
+          ENDDO
+
+!
+!--       Local sum and geometric average of these spectra (WARNING: no global sum should be
+!--       performed, because floating point overflow may occur)
+          DO  i = 0, nx/2
+
+             sums_spectra_l(i) = 1.0_wp
+             DO  j = nys_x, nyn_x
+                sums_spectra_l(i) = sums_spectra_l(i) * ddd(i,j,k)**exponent
+             ENDDO
+
+          ENDDO
+
+       ELSE
+
+          sums_spectra_l = 1.0_wp
+
+       ENDIF
+
+!
+!--    Global sum of spectra on PE0 (from where they are written on file)
+       sums_spectra(:,n) = 0.0_wp
+#if defined( __parallel )
+       CALL MPI_BARRIER( comm2d, ierr )  ! Necessary?
+       CALL MPI_REDUCE( sums_spectra_l(0), sums_spectra(0,n), nx/2+1, MPI_REAL, MPI_PROD, 0,       &
+                        comm2d, ierr )
+#else
+       sums_spectra(:,n) = sums_spectra_l
+#endif
+!
+!--    Normalize spectra by variance
+       sum_spec_dum = SUM( sums_spectra(1:nx/2,n) )
+
+       IF ( sum_spec_dum /= 0.0_wp )  THEN
+          sums_spectra(1:nx/2,n) = sums_spectra(1:nx/2,n) * var_d(k) / sum_spec_dum
+       ENDIF
+       n = n + 1
+
+    ENDDO
+    n = n - 1
+
+    IF ( myid == 0 )  THEN
+!
+!--    Sum of spectra for later averaging (see routine data_output_spectra)
+       DO  i = 1, nx/2
+          DO k = 1, n
+             spectrum_x(i,k,m) = spectrum_x(i,k,m) + sums_spectra(i,k)
+          ENDDO
+       ENDDO
+
+    ENDIF
+!
+!-- n_sp_x is needed by data_output_spectra_x
+    n_sp_x = n
+
+ END SUBROUTINE calc_spectra_x
+#endif
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @todo Missing subroutine description.
+!--------------------------------------------------------------------------------------------------!
+#if defined( __parallel )
+ SUBROUTINE calc_spectra_y( ddd, m )
+
+    USE fft_xy,                                                                                    &
+        ONLY:  fft_y_1d
+
+    USE grid_variables,                                                                            &
+        ONLY:  dy
+
+    USE indices,                                                                                   &
+        ONLY:  nx,                                                                                 &
+               ny
+
+    USE kinds
+
+#if !defined( __mpifh )
+    USE MPI
+#endif
+
+    USE pegrid,                                                                                    &
+        ONLY:  comm2d,                                                                             &
+               ierr,                                                                               &
+               myid
+
+    USE transpose_indices,                                                                         &
+        ONLY:  nxl_yd,                                                                             &
+               nxr_yd,                                                                             &
+               nzb_yd,                                                                             &
+               nzt_yd
+
+
+    IMPLICIT NONE
+
+#if defined( __mpifh )
+    INCLUDE "mpif.h"
+#endif
+
+    INTEGER(iwp) ::  i  !<
+    INTEGER(iwp) ::  j  !<
+    INTEGER(iwp) ::  k  !<
+    INTEGER(iwp) ::  m  !<
+    INTEGER(iwp) ::  n  !<
+
+    REAL(wp) ::  exponent  !<
+    REAL(wp) ::  sum_spec_dum  !< wavenumber-integrated spectrum
+
+    REAL(wp), DIMENSION(0:ny) ::  work  !<
+
+    REAL(wp), DIMENSION(0:ny/2) ::  sums_spectra_l  !<
+
+    REAL(wp), DIMENSION(0:ny/2,100) ::  sums_spectra  !<
+
+    REAL(wp), DIMENSION(0:ny,nxl_yd:nxr_yd,nzb_yd:nzt_yd) :: ddd  !<
+
+
+!
+!-- Exponent for geometric average
+    exponent = 1.0_wp / ( nx + 1.0_wp )
+
+!
+!-- Loop over all levels defined by the user
+    n = 1
+    DO WHILE ( comp_spectra_level(n) /= 999999  .AND.  n <= 100 )
+
+       k = comp_spectra_level(n)
+
+!
+!--    Calculate FFT only if the corresponding level is situated on this PE
+       IF ( k >= nzb_yd  .AND.  k <= nzt_yd )  THEN
+
+          DO  i = nxl_yd, nxr_yd
+
+             work = ddd(0:ny,i,k)
+             CALL fft_y_1d( work, 'forward' )
+
+             ddd(0,i,k) = dy * work(0)**2
+             DO  j = 1, ny/2
+                ddd(j,i,k) = dy * ( work(j)**2 + work(ny+1-j)**2 )
+             ENDDO
+
+          ENDDO
+
+!
+!--       Local sum and geometric average of these spectra (WARNING: no global sum should be
+!--       performed, because floating point overflow may occur)
+          DO  j = 0, ny/2
+
+             sums_spectra_l(j) = 1.0_wp
              DO  i = nxl_yd, nxr_yd
-
-                work = ddd(0:ny,i,k)
-                CALL fft_y_1d( work, 'forward' )
-
-                ddd(0,i,k) = dy * work(0)**2
-                DO  j = 1, ny/2
-                   ddd(j,i,k) = dy * ( work(j)**2 + work(ny+1-j)**2 )
-                ENDDO
-
+                sums_spectra_l(j) = sums_spectra_l(j) * ddd(j,i,k)**exponent
              ENDDO
 
-!
-!--          Local sum and geometric average of these spectra
-!--          (WARNING: no global sum should be performed, because floating
-!--          point overflow may occur)
-             DO  j = 0, ny/2
-
-                sums_spectra_l(j) = 1.0_wp
-                DO  i = nxl_yd, nxr_yd
-                   sums_spectra_l(j) = sums_spectra_l(j) * ddd(j,i,k)**exponent
-                ENDDO
-
-             ENDDO
-          
-          ELSE
-
-             sums_spectra_l = 1.0_wp
-
-          ENDIF
-
-!
-!--       Global sum of spectra on PE0 (from where they are written on file)
-          sums_spectra(:,n) = 0.0_wp
-#if defined( __parallel )   
-          CALL MPI_BARRIER( comm2d, ierr )  ! Necessary?
-          CALL MPI_REDUCE( sums_spectra_l(0), sums_spectra(0,n), ny/2+1,       &
-                           MPI_REAL, MPI_PROD, 0, comm2d, ierr )
+          ENDDO
+
+       ELSE
+
+          sums_spectra_l = 1.0_wp
+
+       ENDIF
+
+!
+!--    Global sum of spectra on PE0 (from where they are written on file)
+       sums_spectra(:,n) = 0.0_wp
+#if defined( __parallel )
+       CALL MPI_BARRIER( comm2d, ierr )  ! Necessary?
+       CALL MPI_REDUCE( sums_spectra_l(0), sums_spectra(0,n), ny/2+1, MPI_REAL, MPI_PROD, 0,       &
+                        comm2d, ierr )
 #else
-          sums_spectra(:,n) = sums_spectra_l
-#endif
-!
-!--       Normalize spectra by variance
-          sum_spec_dum = SUM( sums_spectra(1:ny/2,n) )
-          IF ( sum_spec_dum /= 0.0_wp )  THEN
-             sums_spectra(1:ny/2,n) = sums_spectra(1:ny/2,n) *                 &
-                                      var_d(k) / sum_spec_dum
-          ENDIF
-          n = n + 1
-
+       sums_spectra(:,n) = sums_spectra_l
+#endif
+!
+!--    Normalize spectra by variance
+       sum_spec_dum = SUM( sums_spectra(1:ny/2,n) )
+       IF ( sum_spec_dum /= 0.0_wp )  THEN
+          sums_spectra(1:ny/2,n) = sums_spectra(1:ny/2,n) * var_d(k) / sum_spec_dum
+       ENDIF
+       n = n + 1
+
+    ENDDO
+    n = n - 1
+
+
+    IF ( myid == 0 )  THEN
+!
+!--    Sum of spectra for later averaging (see routine data_output_spectra)
+       DO  j = 1, ny/2
+          DO k = 1, n
+             spectrum_y(j,k,m) = spectrum_y(j,k,m) + sums_spectra(j,k)
+          ENDDO
        ENDDO
-       n = n - 1
-
-
-       IF ( myid == 0 )  THEN
-!
-!--       Sum of spectra for later averaging (see routine data_output_spectra)
-          DO  j = 1, ny/2
-             DO k = 1, n
-                spectrum_y(j,k,m) = spectrum_y(j,k,m) + sums_spectra(j,k)
-             ENDDO
-          ENDDO
-
-       ENDIF
-
-!
-!--    n_sp_y is needed by data_output_spectra_y
-       n_sp_y = n
-
-    END SUBROUTINE calc_spectra_y
+
+    ENDIF
+
+!
+!-- n_sp_y is needed by data_output_spectra_y
+    n_sp_y = n
+
+ END SUBROUTINE calc_spectra_y
 #endif
 
